// Generated by CoffeeScript 2.5.1
var Clutter, DND, EXTENSION_NAME, Extension, ExtensionUtils, GObject, Gettext, Gio, Main, Meta, PanelMenu, PopupMenu, Shell, St, init, tr;

EXTENSION_NAME = 'vertical-windows-list';

GObject = imports.gi.GObject;

St = imports.gi.St;

Gio = imports.gi.Gio;

Meta = imports.gi.Meta;

Clutter = imports.gi.Clutter;

Shell = imports.gi.Shell;

DND = imports.ui.dnd;

ExtensionUtils = imports.misc.extensionUtils;

Gettext = imports.gettext.domain(EXTENSION_NAME);

tr = Gettext.gettext;

ExtensionUtils = imports.misc.extensionUtils;

Main = imports.ui.main;

PanelMenu = imports.ui.panelMenu;

PopupMenu = imports.ui.popupMenu;

Extension = class Extension {
  constructor() {
    this.windowPanel = null;
  }

  enable() {
    var i, len, ref, window, workspace;
    this.monitor = Main.layoutManager.primaryMonitor;
    this.settings = ExtensionUtils.getSettings('org.gnome.shell.extensions.vertical-window-list');
    this.windowPanel = new St.Widget({
      style_class: 'windows-panel',
      reactive: true,
      track_hover: true,
      visible: true,
      layout_manager: new Clutter.BinLayout()
    });
    this.settings.connect('changed::panel-opacity', this.opacityChanged.bind(this));
    this.opacityChanged();
    this.box = new St.BoxLayout({
      x_expand: true,
      y_expand: true
    });
    this.windowPanel.add_child(this.box);
    this.settings.connect('changed::width', this.widthChanged.bind(this));
    this.widthChanged();
    this.windowPanel.height = this.monitor.height;
    this.windowPanel.set_position(this.monitor.x, 30);
    this.windowList = new St.Widget({
      style_class: 'windows-list',
      reactive: true,
      layout_manager: new Clutter.BoxLayout({
        homogeneous: true,
        orientation: Clutter.Orientation.VERTICAL
      }),
      y_align: Clutter.ActorAlign.START,
      x_expand: false,
      y_expand: true
    });
    this.box.add_child(this.windowList);
    this.windowList.set_opacity_override(255);
    workspace = global.workspace_manager.get_active_workspace();
    ref = global.get_window_actors();
    for (i = 0, len = ref.length; i < len; i++) {
      window = ref[i];
      this.add_window(workspace, window.metaWindow);
    }
    workspace.connect_after('window-added', this.add_window.bind(this));
    workspace.connect_after('window-removed', this.remove_window.bind(this));
    Main.layoutManager.addChrome(this.windowPanel, {
      affectsStruts: true,
      trackFullscreen: true
    });
    // cycle windows keybingings
    this.cycling = false;
    Main.wm.addKeybinding('cycle-up', this.settings, Meta.KeyBindingFlags.NONE, Shell.ActionMode.NORMAL, this.cycleWindow.bind(this, true));
    return Main.wm.addKeybinding('cycle-down', this.settings, Meta.KeyBindingFlags.NONE, Shell.ActionMode.NORMAL, this.cycleWindow.bind(this, false));
  }

  cycleWindow(up, display, window, binding) {
    var activeWindow, b, buttons, ix;
    // cycle up or down the list starting from previous Window
    buttons = this.windowList.get_children();
    [activeWindow, ix] = ((function() {
      var i, len, results;
      results = [];
      for (ix = i = 0, len = buttons.length; i < len; ix = ++i) {
        b = buttons[ix];
        if (b.has_style_class_name('focused')) {
          results.push([b.metaWindow, ix]);
        }
      }
      return results;
    })())[0] || [];
    if (activeWindow == null) {
      return;
    }
    if (this.cycling === false) {
      this.activateWindow(this.previousWindow(activeWindow));
      this.cycling = true;
      return;
    }
    if (up) {
      ix = (ix === buttons.length - 1) ? 0 : ix + 1;
    } else {
      ix = ix === 0 ? buttons.length - 1 : ix - 1;
    }
    this.activateWindow(buttons[ix].metaWindow);
    return this.cycling = true;
  }

  widthChanged() {
    return this.windowPanel.width = this.settings.get_int('width');
  }

  opacityChanged() {
    return this.windowPanel.set_opacity(this.settings.get_int('panel-opacity'));
  }

  add_window(workspace, metaWindow) {
    var b, button, i, icon, layout, len, ref, signal1, signal2, texture_cache;
    ref = this.windowList.get_children();
    for (i = 0, len = ref.length; i < len; i++) {
      b = ref[i];
      if (b.metaWindow === metaWindow) {
        return;
      }
      if (metaWindow.is_skip_taskbar()) {
        return;
      }
    }
    button = new St.Button({
      style_class: 'window-button',
      can_focus: true,
      x_expand: true,
      button_mask: St.ButtonMask.ONE | St.ButtonMask.TWO | St.ButtonMask.THREE
    });
    button.metaWindow = metaWindow;
    button.connect('clicked', this.buttonClicked.bind(this, metaWindow));
    layout = new St.BoxLayout({
      style_class: 'window-button-layout',
      x_expand: false,
      y_expand: true
    });
    button.set_child(layout);
    icon = new St.Bin({
      style_class: 'window-button-icon'
    });
    layout.add(icon);
    texture_cache = St.TextureCache.get_default();
    texture_cache.connect('icon-theme-changed', this.updateIcon.bind(this, metaWindow, icon));
    metaWindow.connect_after('notify::wm-class', this.updateIcon.bind(this, metaWindow, icon));
    metaWindow.connect_after('notify::gtk-application-id', this.updateIcon.bind(this, metaWindow, icon));
    this.settings.connect('changed::icon-size', this.updateIcon.bind(this, metaWindow, icon));
    this.updateIcon(metaWindow, icon);
    button.title = new St.Label({
      y_align: Clutter.ActorAlign.CENTER,
      text: '',
      style_class: 'window-button-text'
    });
    button.title.clutter_text.single_line_mode = true;
    layout.add(button.title);
    signal1 = metaWindow.connect('notify::title', this.updateTitle.bind(this, metaWindow, button));
    button.connect('destroy', function() {
      return metaWindow.disconnect(signal1);
    });
    signal2 = global.display.connect('notify::focus-window', this.focusWindow.bind(this, button));
    button.connect('destroy', function() {
      return global.display.disconnect(signal2);
    });
    button.custom_title = new St.Entry({
      y_align: Clutter.ActorAlign.CENTER,
      text: '',
      style_class: 'window-button-editor',
      visible: false
    });
    this.updateTitle(metaWindow, button);
    layout.add(button.custom_title);
    button.custom_title.connect('key-release-event', (custom_title, event) => {
      var ref1;
      if ((ref1 = event.get_key_code()) === 36 || ref1 === 104) { // Enter
        button.custom_title.visible = false;
        button.title.visible = true;
        return this.updateTitle(metaWindow, button);
      }
    });
    this.windowList.add_child(button);
    // windows reordering via drag and drop
    button.draggable = DND.makeDraggable(button, {
      dragActorOpacity: 127
    });
    button.draggable.connect('drag-end', this.dragEnd.bind(this, button));
    return button.draggable.connect('drag-begin', function() {
      var dragActor, posX, posY, sizeH, sizeW;
      dragActor = new St.Button({
        style_class: 'drag-button',
        label: '' + metaWindow.title
      });
      [sizeW, sizeH] = button.get_size();
      dragActor.set_size(sizeW, sizeH);
      [posX, posY] = button.get_transformed_position();
      dragActor.set_position(posX, posY);
      dragActor.getDragActor = function() {
        return dragActor;
      };
      return button._delegate = dragActor;
    });
  }

  dragEnd(button) {
    var b, bRect, dropRect, i, ix, len, ref;
    dropRect = new Meta.Rectangle({
      x: button.draggable._dragX,
      y: button.draggable._dragY,
      width: 1,
      height: 1
    });
    ref = this.windowList.get_children();
    for (ix = i = 0, len = ref.length; i < len; ix = ++i) {
      b = ref[ix];
      bRect = new Meta.Rectangle({
        x: b.get_transformed_position()[0],
        y: b.get_transformed_position()[1],
        width: b.get_transformed_size()[0],
        height: b.get_transformed_size()[1]
      });
      if (b === button) {
        continue;
      }
      if (bRect.contains_rect(dropRect)) {
        this.windowList.remove_child(button);
        this.windowList.insert_child_at_index(button, ix);
      }
    }
    // drag under last window
    if (dropRect.y > bRect.y) {
      this.windowList.remove_child(button);
      return this.windowList.add_child(button);
    }
  }

  remove_window(workspace, metaWindow) {
    var button, i, len, ref, results;
    ref = this.windowList.get_children();
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      button = ref[i];
      if (button.metaWindow === metaWindow) {
        results.push(button.destroy());
      } else {
        results.push(void 0);
      }
    }
    return results;
  }

  focusWindow(button) {
    if (global.display.focus_window === button.metaWindow) {
      return button.add_style_class_name('focused');
    } else {
      return button.remove_style_class_name('focused');
    }
  }

  updateTitle(metaWindow, button) {
    return button.title.set_text(button.custom_title.text || ('' + metaWindow.title));
  }

  app(metaWindow) {
    return Shell.WindowTracker.get_default().get_window_app(metaWindow);
  }

  updateIcon(metaWindow, icon) {
    var ref;
    return icon.child = ((ref = this.app(metaWindow)) != null ? ref.create_icon_texture(this.settings.get_int('icon-size')) : void 0) || new St.Icon({
      icon_name: 'icon-missing',
      icon_size: this.settings.get_int('icon-size')
    });
  }

  buttonClicked(metaWindow, button, button_number) {
    var prevWindow;
    // activate previous window if already was active
    if (button_number === 1) {
      if (metaWindow.appears_focused) {
        prevWindow = this.previousWindow(metaWindow);
        this.activateWindow(prevWindow);
      } else {
        this.activateWindow(metaWindow);
      }
      return;
    }
    if (button_number === 2) {
      button.title.visible = false;
      button.custom_title.visible = true;
      button.custom_title.x_expand = true;
      button.custom_title.grab_key_focus();
      return;
    }
    // close window on right click
    if (button_number === 3) {
      this.activateWindow(metaWindow);
      metaWindow.delete(global.get_current_time());
    }
  }

  activateWindow(metaWindow) {
    metaWindow.activate(global.get_current_time());
    return this.cycling = false;
  }

  previousWindow(metaWindow) {
    return global.display.get_tab_next(Meta.TabList.NORMAL, metaWindow.get_workspace(), metaWindow, false);
  }

  disable() {
    this.windowPanel.destroy();
    return this.windowPanel = null;
  }

};

init = function() {
  return new Extension();
};
